var slideshow, slideSelect;

var shares = null;
// H5 plus事件处理
function plusReady() {
    plus.navigator.setFullscreen(true);
    updateSerivces();
}
if(window.plus) {
    plusReady();
} else {
    document.addEventListener('plusready', plusReady, false);
}
/**
 * 更新分享服务
 */
function updateSerivces() {
    plus.share.getServices(function(s) {
        shares = {};
        for(var i in s) {
            var t = s[i];
            shares[t.id] = t;
        }
    }, function(e) {});
}

// banner信息
var requestBanner = function() {
    var channelId = getParam('td_channelid');
    var plat = getPlat(channelId);
    var deviceId = getDeviceId();
    var request = pegasus("https://{0}/GameConfig.php?data={%22game_id%22:{1},%22plat%22:{2}}&device_id={3}&channel_name={4}".formatzj(BANNER_IP, GAME_ID, plat, deviceId, channelId));
    request.then(

        // success handler
        function(data, xhr) {
            // Convert HTML...
            var res = JSON.parse(xhr.response);
            if(res.code == 0) {
                // banner
                var ran = randomzj(0, res.data.banner.length - 1);
                var ranData = res.data.banner[ran];
                for(var i = res.data.banner.length - 1; i >= 0; i--) {
                    $("#bannerImg").src = ranData.banner_url;
                    // $("#bannerLink").href = ranData.jump_url;
                    // todo 区分pc和移动端
                    $("#bannerLink").onclick = function() {
                        adLog(CLICK_BANNER, ranData.ads_id);
                        plus.runtime.openURL(ranData.jump_url);
                    };
                    $("#bannerFooter").style.display = "block";
                    break;
                }

                if(res.data.moreGame.length > 0)
                {
                    $("#moregamezj").style.display = "block";
                    $("#moregamezj").onclick = function() {
                        $("#moregamelistzj").style.display = "block";
                    };
                    $("#more_close").onclick = function() {
                        $("#moregamelistzj").style.display = "none";
                    };
                    var yDis = 180;
                    var yOffset = 200;
                    var urlList = [];
                    for(var i = res.data.moreGame.length - 1; i >= 0; i--) {
                        var moreData = res.data.moreGame[i];
                        var newDiv = document.createElement("div");
                        newDiv.id = "bannerBlock"+i;
                        newDiv.className = "bannerBlock";

                        document.getElementById("moregamelistzj").appendChild(newDiv);
                        
                        $("#bannerBlock"+i).style.left = 20;
                        
                        $("#bannerBlock"+i).style.top = (i * yDis) + yOffset;
                        var myImg = document.createElement("img");
                        myImg.setAttribute("style","position: absolute;");
                        var myP = document.createElement("p");
                        myP.setAttribute("style","font-size: 50px;font-weight: bold;color: #FFFFFF;position:absolute;left: 150px;");
                        var line = document.createElement("div");
                        line.setAttribute("style", "background: #ffffff;width: 95%;width: calc(100% - 40px);height: 5px;position: absolute;bottom: 20px;");
                        
                        newDiv.appendChild(myImg);
                        newDiv.appendChild(myP);
                        newDiv.appendChild(line);
                        
                        myImg.setAttribute("src", moreData.banner_url);
                        newDiv.jump_url = moreData.jump_url;
                        newDiv.adID = moreData.ads_id;
                        $("#bannerBlock"+i).onclick = function() {
                            adLog(CLICK_MORE, this.adID);
                            plus.runtime.openURL(this.jump_url);
                        };
                        myP.innerText = moreData.ads_desc;
                    }
                }

                // game
                var game = res.data.game;
                SHARE_LINK = game.share_url || SHARE_LINK;
                SHARE_TITLE_CHAT = game.share_title_chat || SHARE_TITLE_CHAT;
                SHARE_CONTENT_CHAT = game.share_content_chat || SHARE_CONTENT_CHAT;
                SHARE_TITLE_PYQ = game.share_title_pyq || SHARE_TITLE_PYQ;
                SHARE_CONTENT_PYQ = game.share_content_pyq || SHARE_CONTENT_PYQ;
                SHARE_TITLE_QQ = game.share_title_qq || SHARE_TITLE_QQ;
                SHARE_CONTENT_QQ = game.share_content_qq || SHARE_CONTENT_QQ;

                SHARE_TITLE_WEIBO = game.share_title_weibo || SHARE_TITLE_WEIBO;
                SHARE_CONTENT_WEIBO = game.share_content_weibo || SHARE_CONTENT_WEIBO;
                SHARE_TITLE_FB = game.share_title_fb || SHARE_TITLE_FB;
                SHARE_CONTENT_FB = game.share_content_fb || SHARE_CONTENT_FB;
                SHARE_TITLE_TWITTER = game.share_title_twitter || SHARE_TITLE_TWITTER;
                SHARE_CONTENT_TWITTER = game.share_content_twitter || SHARE_CONTENT_TWITTER;
                EVALUATE_A = game.evaluate || EVALUATE_A;
                EVALUATE_I = game.evaluate || EVALUATE_I;
            }
        },
        // error handler (optional)
        function(data, xhr) {
            // alert("AHHHHHHHHHHHH, PROBLEM LOADING WORDS");
            console.error(data, xhr.status)
        }
    );
}

// talkingdata
var tdAccount = function() {
    if(typeof(TDGA) != "undefined") {
        TDGA.Account({
            accountId: TDGA.getDeviceId(),
            level: 1,
            gameServer: '服务器',
            accountType: 1,
            age: 24,
            accountName: '昵称',
            gender: 1
        });
    } else {
        setTimeout("tdAccount()", 3000);
    }
}

var setLanguage = function(browserLanguage) {
    if(browserLanguage == 'zh-cn' || browserLanguage == 'zh-ch') {
        LANGUAGE = "chinese";
        LANG_SUFFIX = "";
        SHARE_UI_TITLE = '分享链接';
        SHARE_UI_CANCEL = '取消';
        SHARE_UI_ALERT = '当前环境无法支持分享链接操作!';
        EVALUATE_UI_TITLE = '求鼓励！求信任！';
        EVALUATE_UI_CONTENT = '听说信任我们游戏的人\n都会去商店评分的噢！';
        EVALUATE_UI_GO_LATER = '稍后再去';
        EVALUATE_UI_GO_NOW = '去！';
    } else if(browserLanguage == 'zh-tw' || browserLanguage == 'zh-hk' ||
        browserLanguage == 'zh-mo') {
        LANGUAGE = "chinese_td";
        LANG_SUFFIX = "_td";
        SHARE_UI_TITLE = '分享鏈接';
        SHARE_UI_CANCEL = '取消';
        SHARE_UI_ALERT = '當前環境無法支持分享鏈接操作!';
        EVALUATE_UI_TITLE = '求鼓勵！求信任！';
        EVALUATE_UI_CONTENT = '聽說信任我們遊戲的人\n都會去商店評分的噢！';
        EVALUATE_UI_GO_LATER = '稍後再去';
        EVALUATE_UI_GO_NOW = '去！';
    } else {
        LANGUAGE = "english";
        LANG_SUFFIX = "_en";
        SHARE_UI_TITLE = 'Share links';
        SHARE_UI_CANCEL = 'Cancel';
        SHARE_UI_ALERT = 'The current environment can not support sharing links!';
        EVALUATE_UI_TITLE = 'Encouragement and trust!';
        EVALUATE_UI_CONTENT = 'If you trust us, please make\nrecommendations in the app store.';
        EVALUATE_UI_GO_LATER = 'Not Now';
        EVALUATE_UI_GO_NOW = 'OK';        
    }
}

window.onload = function() {
    // 适配
    var rate = screen.height / 1920 * 1.5;
    document.body.style.zoom = rate;
    tdAccount();

    // 检测浏览器语言
    var browserLanguage = (navigator.language || navigator.browserLanguage).toLowerCase();
    if(EN_VER == "true")
    {
        browserLanguage = "en";
    }
    setLanguage(browserLanguage);

    // PRELOADER
    Q.all([
        Loader.loadAssets(Loader.manifestPreload),
        // load language
        Words.convertByLanguage('true')
    ]).then(function() {
        // close splash
        if(typeof plus !== "undefined") {
            plus.navigator.closeSplashscreen();
        }

        // CHANGE DOM
        document.body.removeChild($("#preloader"));
        $("#main").style.display = "block";
        if(TEST == "true") {
            $("#footer").style.display = "block";
        }

        $("#headerzj").style.display = "block";
        if(browserzj.versions.iPhone || browserzj.versions.iPad || browserzj.versions.ios || browserzj.versions.android) {
            $("#evaluatezj").style.display = "block";
        }

        // Slideshow
        slideshow = new Slideshow({
            dom: $("#slideshow"),
            slides: SLIDES
        });

        // Slide Select
        slideSelect = new SlideSelect({
            dom: $("#select"),
            slides: SLIDES
        });
        slideSelect.dom.style.display = "none";
        subscribe("start/game", function() {
            slideSelect.dom.style.display = "block";
            $("#translations").style.display = "none";

            // [FOR DEBUGGING]
            publish("slideshow/next");
            //publish("slideshow/scratch", ["credits"]);

        });
        subscribe("start/game_no_publish", function() {
            slideSelect.dom.style.display = "block";
            $("#translations").style.display = "none";

        });

        // SOUND
        var _soundIsOn = true;
        $("#sound_icon").onclick = function() {
            _soundIsOn = !_soundIsOn;
            Howler.mute(!_soundIsOn);
            $("#sound").setAttribute("sound", _soundIsOn ? "on" : "off");
        };

        // LANG
        if(LANG_TURN_ON == "true") {
            $("#lang_icon").onclick = function() {
                LANGUAGE = LANGUAGE == "chinese" ? "english" : "chinese";
                $("#lang").setAttribute("lang", LANGUAGE);
                publish("slideshow/goto", [SLIDE_ID]);
                $("#lang").setAttribute("lang", LANGUAGE == "chinese" ? "chinese" : "english");
            }
        } else {
            var langDiv = document.getElementById("lang");
            langDiv.style.visibility = "hidden";
        }

        // LOAD REAL THINGS
        Loader.loadAssets(
            Loader.manifest,
            function() {
                $("#sharezj").onclick = function() {
                    shareHref();
                };
                $("#evaluatezj").onclick = function() {
                    showEvaluate();
                };
                requestBanner();
                publish("preloader/done");
            },
            function(ratio) {
                publish("preloader/progress", [ratio]);
            }
        );

        // First slide!
        slideshow.nextSlide();
    });

};