///////////// zj 扩展方法
function randomzj(min, max){
  return Math.floor(Math.random()*(max-min+1)+min);
}

String.prototype.formatzj = function()
{
    var args = arguments;
    return this.replace(/\{(\d+)\}/g,
        function(m,i){
            return args[i];
        });
}

function writeObj(obj){ 
 var description = ""; 
 for(var i in obj){ 
 var property=obj[i]; 
 description+=i+" = "+property+"\n"; 
 } 
 alert(description); 
} 

var browserzj={
    versions:function(){
        var u = navigator.userAgent, app = navigator.appVersion;
        return { //移动终端浏览器版本信息
            trident: u.indexOf('Trident') > -1, //IE内核
            presto: u.indexOf('Presto') > -1, //opera内核
            webKit: u.indexOf('AppleWebKit') > -1, //苹果、谷歌内核
            gecko: u.indexOf('Gecko') > -1 && u.indexOf('KHTML') == -1, //火狐内核
            mobile: !!u.match(/AppleWebKit.*Mobile.*/), //是否为移动终端
            ios: !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/), //ios终端
            android: u.indexOf('Android') > -1 || u.indexOf('Linux') > -1, //android终端或uc浏览器
            iPhone: u.indexOf('iPhone') > -1 , //是否为iPhone或者QQHD浏览器
            iPad: u.indexOf('iPad') > -1, //是否iPad
            webApp: u.indexOf('Safari') == -1 //是否web应该程序，没有头部与底部
        };
    }(),
    language:(navigator.browserLanguage || navigator.language).toLowerCase()
}

if (!Array.prototype.find) {
  Object.defineProperty(Array.prototype, 'find', {
    value: function(predicate) {
     // 1. Let O be ? ToObject(this value).
      if (this == null) {
        throw new TypeError('"this" is null or not defined');
      }

      var o = Object(this);

      // 2. Let len be ? ToLength(? Get(O, "length")).
      var len = o.length >>> 0;

      // 3. If IsCallable(predicate) is false, throw a TypeError exception.
      if (typeof predicate !== 'function') {
        throw new TypeError('predicate must be a function');
      }

      // 4. If thisArg was supplied, let T be thisArg; else let T be undefined.
      var thisArg = arguments[1];

      // 5. Let k be 0.
      var k = 0;

      // 6. Repeat, while k < len
      while (k < len) {
        // a. Let Pk be ! ToString(k).
        // b. Let kValue be ? Get(O, Pk).
        // c. Let testResult be ToBoolean(? Call(predicate, T, « kValue, k, O »)).
        // d. If testResult is true, return kValue.
        var kValue = o[k];
        if (predicate.call(thisArg, kValue, k, o)) {
          return kValue;
        }
        // e. Increase k by 1.
        k++;
      }

      // 7. Return undefined.
      return undefined;
    }
  });
}


/**
* 获取函数名称
*
* @param {Function} func 函数引用
* @return {String} 函数名称
*/
function getFunctionName(func) {
  if ( typeof func == 'function' || typeof func == 'object' ) {
    var name = ('' + func).match(/function\s*([\w\$]*)\s*\(/);
  }
  return name && name[1];
}
if (!('console' in window)) {
  window.console = {};
}
if (!console.trace) {
  /**
   * 显示函数堆栈<br/>
   * 为了和Firebug统一，将trace方法添加到console对象中
   *
   * @param {Function} func 函数引用
   *
   * @example
function a() {
b();
}
function b() {
c();
}
function c() {
d();
}
function d() {
console.trace();
}
a();
   */
console.trace = function() {
    var stack = [],
      caller = arguments.callee.caller;
    while (caller) {
      stack.unshift(getFunctionName(caller));
      caller = caller && caller.caller;
    }
    alert('functions on stack:' + '\n' + stack.join('\n'));
  }
};

///////////// 网络
var getParam = function getQueryString(name) {
  var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
  var r = window.location.search.substr(1).match(reg);
  if(r != null) return unescape(r[2]);
  return null;
}

var guid = function() {
  return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
    var r = Math.random() * 16 | 0,
      v = c == 'x' ? r : (r & 0x3 | 0x8);
    return v.toString(16);
  });
}

var getDeviceId = function() {
  deviceId = window.localStorage.getItem("trust_device_id");
  if(typeof deviceId == 'undefined' || deviceId == null) {
    deviceId = guid();
    deviceId = window.localStorage.setItem("trust_device_id", deviceId);
  }
  return window.localStorage.getItem("trust_device_id");
}

function getPlat(channelId)
{
  if(!channelId) {
    channelId = "";
  }
  var plat = CHANNEL[channelId.toLowerCase()]; // 默认安卓1。历史原因跟别的游戏不一样。
  // if(browserzj.versions.iPhone || browserzj.versions.iPad || browserzj.versions.ios)
  // {
  //   plat = 0;
  // }
  if(typeof plat == "undefined") {
    plat = 1;
  }
  return plat;
}

var CLICK_BANNER = 0;
var CLICK_MORE = 1;
function adLog(clickType,adID)
{
  var channelId = getParam('td_channelid');
  var plat = getPlat(channelId);
  var request = pegasus("https://{0}/AdLog.php?data={%22game_id%22:{1},%22plat%22:{2}}&device_id={3}&channel_name={4}&click={5}&ad_id={6}".formatzj(BANNER_IP, GAME_ID, plat, deviceId, channelId, clickType, adID));
}

///////////// 分享、评论
function showEvaluate(){
      if(browserzj.versions.android)
      {
        showEvaluateAndroid();
      }
      else
      {
        showEvaluateIos();
      }
}

function showEvaluateAndroid(){
  var bts=[EVALUATE_UI_GO_NOW, EVALUATE_UI_GO_LATER];
  plus.nativeUI.confirm(EVALUATE_UI_CONTENT, function(e){
    var i=e.index;
    if(i == 0)
    {
      if(browserzj.versions.android)
      {
        plus.runtime.openURL(EVALUATE_A);
      }
      else
      {
        plus.runtime.openURL(EVALUATE_I);
      }
    }
  },EVALUATE_UI_TITLE, bts);
}
function showEvaluateIos(){
  var bts=[EVALUATE_UI_GO_LATER, EVALUATE_UI_GO_NOW];
  plus.nativeUI.confirm(EVALUATE_UI_CONTENT, function(e){
    var i=e.index;
    if(i == 1)
    {
      if(browserzj.versions.android)
      {
        plus.runtime.openURL(EVALUATE_A);
      }
      else
      {
        plus.runtime.openURL(EVALUATE_I);
      }
    }
  },EVALUATE_UI_TITLE, bts);
}

// 分享链接
function shareHref(){
  var shareBts=[];
  // 更新分享列表
  var ss=shares['weixin'];
  if(EN_VER != "true" && NO_SHARE_CHANNEL != "true")
  {
    ss&&ss.nativeClient&&(shareBts.push({title:'微信朋友圈',s:ss,x:'WXSceneTimeline',shareType:'pyq'}),
    shareBts.push({title:'微信好友',s:ss,x:'WXSceneSession',shareType:'chat'}));
    ss=shares['sinaweibo'];
    ss&&shareBts.push({title:'新浪微博',s:ss,shareType:'weibo'});
    ss=shares['qq'];
    ss&&ss.nativeClient&&shareBts.push({title:'QQ',s:ss,shareType:'qq'});
  }
  
  shareBts.push({title:'facebook', s:"null", shareType:'facebook'});
  shareBts.push({title:'twitter', s:"null", shareType:'twitter'});
  
  // 弹出分享列表
  shareBts.length>0?plus.nativeUI.actionSheet({title:SHARE_UI_TITLE, cancel:SHARE_UI_CANCEL, buttons:shareBts},function(e){
    (e.index>0)&&shareAction(shareBts[e.index-1],true);
  }):plus.nativeUI.alert(SHARE_UI_ALERT);
}

/**
   * 分享操作
   * @param {JSON} sb 分享操作对象s.s为分享通道对象(plus.share.ShareService)
   * @param {Boolean} bh 是否分享链接
   */
function shareAction(sb,bh) {
  if(!sb||!sb.s){
    return;
  }
  var title = SHARE_TITLE_CHAT;
  var content = SHARE_CONTENT_CHAT;
  var link = SHARE_LINK;
  if(sb.shareType == "chat")
  {
    title = SHARE_TITLE_CHAT;
    content = SHARE_CONTENT_CHAT;
  }
  else if(sb.shareType == "pyq")
  {
    title = SHARE_TITLE_PYQ;
    content = SHARE_CONTENT_PYQ;
  }
  else if(sb.shareType == "qq")
  {
    title = SHARE_TITLE_QQ;
    content = SHARE_CONTENT_QQ;
  }
  else if(sb.shareType == "weibo")
  {
    title = SHARE_TITLE_WEIBO;
    content = SHARE_CONTENT_WEIBO + link;
  }
  else if(sb.shareType == "facebook")
  {
    title = SHARE_TITLE_FB;
    content = SHARE_CONTENT_FB;
    plus.runtime.openURL(encodeURI("https://www.facebook.com/sharer/sharer.php?u=" + link + '&t=' + content));  
    return;
  }
  else if(sb.shareType == "twitter")
  {
    title = SHARE_TITLE_TWITTER;
    content = SHARE_CONTENT_TWITTER;
    plus.runtime.openURL(encodeURI("https://twitter.com/intent/tweet?source=" + link + "&text=" + content +' ' + link));       
  return;
  }
  var msg={content:content,extra:{scene:sb.x}};
  if(bh){
    msg.href=link;
    // if(sharehrefTitle&&sharehrefTitle.value!=''){
      msg.title=title;
    // }
    // if(sharehrefDes&&sharehrefDes.value!=''){
      msg.content=content;
    // }
    msg.thumbs=['_www/logo.png'];
    // msg.pictures=['_www/logo.png'];
  }else{
    if(pic&&pic.realUrl){
      msg.pictures=[pic.realUrl];
    }
  }
  // 发送分享
  if(sb.s.authenticated){
    shareMessage(msg, sb.s);
  }else{
    sb.s.authorize(function(){
      shareMessage(msg,sb.s);
    }, function(e){
      console.error("授权失败");
    });
  }
}
/**
   * 发送分享消息
   * @param {JSON} msg
   * @param {plus.share.ShareService} s
   */
function shareMessage(msg, s){
  s.send(msg, function(){
    // outLine('分享到"'+s.description+'"成功！');
  }, function(e){
    // outLine('分享到"'+s.description+'"失败: '+JSON.stringify(e));
  });
}

function ListenPauseAfterNewPixi(pixiApp)
{
  document.addEventListener("pause",function(){
    pixiApp.stop();
  }, false );
  document.addEventListener("resume",function(){
    pixiApp.start();
  }, false );
}